c
c -------------------------------------------------------------------
c
      subroutine bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,ql,qr,
     &           maux,auxl,auxr,t,dt,mthbc)
      implicit double precision (a-h,o-z)
      dimension ql(1-mbc:maxmx+mbc,meqn)
      dimension qr(1-mbc:maxmx+mbc,meqn)
      dimension auxl(1-mbc:maxmx+mbc,maux)
      dimension auxr(1-mbc:maxmx+mbc,maux)
      dimension mthbc(2)
c
c     # Standard boundary condition choices for claw2
c
c     # At each boundary  k = 1 (left),  2 (right):
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary coniditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd component of q.
c     ------------------------------------------------
c
c     # Extend the data from the computational region
c     #      i = 1, 2, ..., mx2
c     # to the virtual cells outside the region, with
c     #      i = 1-ibc  and   i = mx+ibc   for ibc=1,...,mbc
c
c     # left boundary:
      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(1)=0 and no BCs specified in bc1'
      stop
      go to 199
c
 110  continue
c     # zero-order extrapolation:
c
      do m=1,meqn
         do ibc=1,mbc
            ql(1-ibc,m) = ql(1,m)
            qr(1-ibc,m) = qr(1,m)
            enddo
         enddo
      go to 199

 120  continue
c     # periodic:  
c
      do m=1,meqn
         do ibc=1,mbc
            ql(1-ibc,m) = ql(mx+1-ibc,m)
            qr(1-ibc,m) = qr(mx+1-ibc,m)
            enddo
         enddo
      go to 199

 130  continue
c     # solid wall 
c
      do m=1,meqn
         do ibc=1,mbc
            ql(1-ibc,m) = ql(ibc,m)
            qr(1-ibc,m) = qr(ibc,m)
            enddo
         enddo
c
c     # negate the normal velocity:
      do ibc=1,mbc
         ql(1-ibc,3) = -ql(ibc,3)
         qr(1-ibc,3) = -qr(ibc,3)
         enddo
      go to 199
c
 199  continue
c
c     # right boundary:
      go to (200,210,220,230) mthbc(2)+1
c
 200  continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(2)=0 and no BCs specified in bc2'
      stop
      go to 299

 210  continue
c     # zero-order extrapolation:
c
      do m=1,meqn
         do ibc=1,mbc
            ql(mx+ibc,m) = ql(mx,m)
            qr(mx+ibc,m) = qr(mx,m)
            enddo
         enddo
      go to 299
c
 220  continue
c     # periodic:  
c
      do m=1,meqn
         do ibc=1,mbc
            ql(mx+ibc,m) = ql(ibc,m)
            qr(mx+ibc,m) = qr(ibc,m)
            enddo
         enddo
      go to 299

 230  continue
c     # solid wall 
c
      do m=1,meqn
         do ibc=1,mbc
            ql(mx+ibc,m) = ql(mx+1-ibc,m)
            qr(mx+ibc,m) = qr(mx+1-ibc,m)
            enddo
         enddo
c
c     # negate the normal velocity:
      do ibc=1,mbc
         ql(mx+ibc,3) = -ql(mx+1-ibc,3)
         qr(mx+ibc,3) = -qr(mx+1-ibc,3)
         enddo
      go to 299

 299  continue
      return
c
      end
