c
c ------------------------------------------------------------
c
      subroutine ctomfd(q,rhoa0,rhob0,vx0,rhoh0,p0,
     &           pa0,pb0,temp0,zeta0,zfa0,zfb0,
     &           c2a0,c2b0,c20)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      common /eos_local/ rhoe1,rhoe2,temp1,temp2,
     &        S1,S2,gb1,gb2,zeta1,zeta2
      common /p5eqn0/ p00
      dimension q(20)           
c
c     # change variables from conservative to primitive 
c     # 6-equation model with partial total energy
c
      grue1 = geos(1)-1.d0
      grue2 = geos(2)-1.d0
      cp1   = geos(1)*cv(1)
      cp2   = geos(2)*cv(2)
c
      rhoa0 = q(1)
      rhob0 = q(2)
      rho0  = q(1)+q(2)
      rho1  = q(1)/q(6) 
      rho2  = q(2)/q(7)
      vx0   = q(3)/(q(1)+q(2))
      zfa0  = q(6)
      zfb0  = q(7) 
c
      rhok1 = 0.5d0*rho1*vx0**2
      rhok2 = 0.5d0*rho2*vx0**2
      rhoe1 = q(4)/zfa0-rhok1
      rhoe2 = q(5)/zfb0-rhok2
c
c     # phasic pressure
      p1  = grue1*(rhoe1-rho1*cn(1))-geos(1)*bn(1)
      p2  = grue2*(rhoe2-rho2*cn(2))-geos(2)*bn(2)
      pa0 = zfa0*p1
      pb0 = zfb0*p2
c
c     # mixture pressure
      p0 = pa0+pb0
c
c     # phasic temperature
c      temp1 = (rhoe1-rho1*cn(1)-bn(1))/(rho1*cv(1))
c      temp2 = (rhoe2-rho2*cn(2)-bn(2))/(rho2*cv(2))
c
      temp1 = (p1+bn(1))/(cv(1)*rho1*grue1)
      temp2 = (p2+bn(2))/(cv(2)*rho2*grue2)
c
      tempI = ((grue1*temp1/zfa0)+
     &         (grue2*temp2/zfb0))/
     &         (grue1/zfa0+grue2/zfb0)
      temp0 = temp1*temp2/tempI
c
c     # Gibbs free energy: G(p,T) = h(T)-TS(p,T)
      h1  = cp1*temp1+cn(1)
      S1  = cv(1)*dlog(temp1**geos(1)/
     &      (p1+bn(1))**grue1)+dn(1)
      gb1 = h1-temp1*S1
c
      h2  = cp2*temp2+cn(2)
      S2  = cv(2)*dlog(temp2**geos(2)/
     &      (p2+bn(2))**grue2)+dn(2)
      gb2 = h2-temp2*S2
c
c     # Saurel etal: frozen speed of sound
      zc1 = geos(1)*(p1+bn(1))
      zc2 = geos(2)*(p2+bn(2))
      c20 = (zfa0*zc1+zfb0*zc2)/(q(1)+q(2))
c
      c2a0 = zfa0/q(1)*zc1
      c2b0 = zfb0/q(2)*zc2
c
      zeta1 = cn(1)
      zeta2 = cn(2)
      zeta0 = (rhoa0*zeta1+rhob0*zeta2)/rho0
c
      rhoh0 = (q(4)+q(5))+p0
c
c     # mixture pressure (5-equation reduced model)
      ph1   = -geos(1)*bn(1)
      eh1   = cn(1)
      ph2   = -geos(2)*bn(2)
      eh2   = cn(2)
      grue0 = 1.d0/(zfa0/grue1+zfb0/grue2)
      eref0 = rhoa0*eh1+rhob0*eh2
      pref0 = zfa0*ph1/grue1+zfb0*ph2/grue2
      rhoe0 = zfa0*rhoe1+zfb0*rhoe2
      p00   = grue0*(rhoe0-eref0+pref0)
      return
c
      end
