c
c ----------------------------------------------------------
c
      subroutine c2prm(maxm,meqn,mbc,maux,mx,q,qp,aux)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      dimension q(1-mbc:maxm+mbc,meqn)
      dimension qp(1-mbc:maxm+mbc,meqn)
      dimension aux(1-mbc:maxm+mbc,maux)
c
c     # change conservative to primitive
c     # 6-equation model with phasic total energy
c     # linearized Mie-Gruneisen EOS
c
      do i=1-mbc,mx+mbc
         qp(i,1) = q(i,1)
         qp(i,2) = q(i,2)
         qp(i,3) = q(i,3)/(q(i,1)+q(i,2))
         qp(i,4) = (q(i,4)-0.5d0*q(i,1)*qp(i,3)**2)/q(i,6)
         qp(i,5) = (q(i,5)-0.5d0*q(i,2)*qp(i,3)**2)/q(i,7)
         qp(i,6) = q(i,6)     
         qp(i,7) = q(i,7)     
         qp(i,8) = q(i,8)     
         enddo
      return
c
      end
c
c --------------------------------------------------------------
c
      subroutine prm2c_edge(maxmx,meqn,mbc,maux,mx,dx,
     &           ql,qr,auxl,auxr,uu,q,aux)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension ql(1-mbc:maxmx+mbc,meqn)
      dimension qr(1-mbc:maxmx+mbc,meqn)
      dimension auxl(1-mbc:maxmx+mbc,maux)
      dimension auxr(1-mbc:maxmx+mbc,maux)
      dimension uu(1-mbc:maxmx+mbc,meqn,2)
c
c     # change primitive variables to conservative variables
c     # 6-equation model with phasic total energy
c     # linearized Mie-Gruneisen EOS
c
      do i=0,mx+1
c        # left cell-edge 
         ql(i,1) = uu(i,1,1)
         ql(i,2) = uu(i,2,1)
         ql(i,3) = (ql(i,1)+ql(i,2))*uu(i,3,1)
c
         rhok1   = 0.5d0*ql(i,1)*uu(i,3,1)**2
         rhok2   = 0.5d0*ql(i,2)*uu(i,3,1)**2
         ql(i,4) = uu(i,6,1)*uu(i,4,1)+rhok1
         ql(i,5) = uu(i,7,1)*uu(i,5,1)+rhok2
         ql(i,6) = uu(i,6,1)
         ql(i,7) = uu(i,7,1)
         ql(i,8) = uu(i,8,1)
c
c        # right cell-edge
         qr(i,1) = uu(i,1,2)
         qr(i,2) = uu(i,2,2)
         qr(i,3) = (qr(i,1)+qr(i,2))*uu(i,3,2)
c
         rhok1   = 0.5d0*qr(i,1)*uu(i,3,2)**2
         rhok2   = 0.5d0*qr(i,2)*uu(i,3,2)**2
         qr(i,4) = uu(i,6,2)*uu(i,4,2)+rhok1  
         qr(i,5) = uu(i,7,2)*uu(i,5,2)+rhok2  
         qr(i,6) = uu(i,6,2)
         qr(i,7) = uu(i,7,2)
         qr(i,8) = uu(i,8,2)
         enddo
c
c     # positivity-preserving check
      do i=2-mbc,mx+mbc
         if ((ql(i,1) .lt. 0.d0) .or.
     &       (ql(i,2) .lt. 0.d0) .or.
     &       (ql(i,6) .lt. 0.d0) .or.
     &       (ql(i,7) .lt. 0.d0) .or.
     &       (ql(i,8) .lt. 0.d0) .or.
     &       (qr(i,1) .lt. 0.d0) .or.
     &       (qr(i,2) .lt. 0.d0) .or.
     &       (qr(i,6) .lt. 0.d0) .or.
     &       (qr(i,7) .lt. 0.d0) .or.
     &       (qr(i,8) .lt. 0.d0)) then
             write(66,*) 'i=',i
             write(66,*) 'left-state'
             write(66,*) (ql(i,m),m=1,meqn)
             write(66,*) 'right-state'
             write(66,*) (qr(i,m),m=1,meqn)
             write(66,*) 'orig-state'
             write(66,*) (q(i,m),m=1,meqn)
             stop
         endif
         enddo
      return
c
      end
