c
c ------------------------------------------------------------
c
      double precision function fp_relax(p0)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &       dn(10),en(10),rref(10),c2ref(10),tref(10),
     &       cv(10),emu(10),rhocav(10),pcav(10),
     &       ccav(10),rhosat(10),psat(10),csat(10),
     &       rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &       mwoods,mphase
      common /prelx0/ rhoa0,rhob0,rho10,rho20,
     &        e10,e20,phat0
      common /prelx1/ zfa0,zfb0
      common /density0/ pp,phat,ek0,rhok0,rho_iter(20),k    
c
c     # saturation equation for mechanical equilibrium
c
      pp   = p0
      phat = p0
c      phat = 0.5d0*(p0+phat0)
c      phat = phat0
c
c     # linearized Mie-Gruneisen EOS
      k = 1
      rhok0 = rho10
      ek0   = e10-cn(k)  
      gruek = geos(k)-1.d0
      rhoek = (p0+geos(k)*bn(k))/gruek
      rho1  = (rhoek+phat)/(ek0+phat/rhok0)
      rho_iter(1) = rho1
c
c     # linearized Mie-Gruneisen EOS
      k = 2
      rhok0 = rho20
      ek0   = e20-cn(k)   
      gruek = geos(k)-1.d0
      rhoek = (p0+geos(k)*bn(k))/gruek
      rho2  = (rhoek+phat)/(ek0+phat/rhok0)
      rho_iter(2) = rho2
c
      zfa0 = rhoa0/rho1
      zfb0 = rhob0/rho2
c
      fp_relax = zfa0+zfb0-1.d0
      return
c
      end
c
c ------------------------------------------------------------
c
      double precision function dfp_relax(p0)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &       dn(10),en(10),rref(10),c2ref(10),tref(10),
     &       cv(10),emu(10),rhocav(10),pcav(10),
     &       ccav(10),rhosat(10),psat(10),csat(10),
     &       rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &       mwoods,mphase
      common /prelx0/ rhoa0,rhob0,rho10,rho20,
     &        e10,e20,phat0
      common /prelx1/ zfa0,zfb0
      common /density0/ pp,phat,ek0,rhok0,rho_iter(20),k    
c
c     # derivative with respect to pressure for
c     # saturation equation for mechanical equilibrium        
c
      pp    = p0
      phat  = p0
      dphat = 1.0d0
c
c     # phase 1: linearized Mie-Gruneisen EOS
      rho1  = rho_iter(1)
      tau1  = 1.d0/rho1
      tau10 = 1.d0/rho10
      grue1 = geos(1)-1.d0
      ph1   = -geos(1)*bn(1)
      dph1  = 0.d0
      deh1  = 0.d0
c
c     # derivative with respective to pressure   
      term1a = deh1+(-tau1*dph1+p0-ph1)/grue1+phat
      term1b = tau1/grue1+(tau1-tau10)*dphat
      if (term1a .ne. 0.d0) then
          dtau1 = -term1b/term1a
      else
          write(6,*) 'term1a=',term1a
          stop
      endif
c
c     # phase 2: linearized Mie-Gruneisen EOS
      rho2  = rho_iter(2)
      tau2  = 1.d0/rho2
      tau20 = 1.d0/rho20
      grue2 = geos(2)-1.d0
      ph2   = -geos(2)*bn(2)
      dph2  = 0.d0
      deh2  = 0.d0
c
c     # derivative with respective to pressure   
      term2a = deh2+(-tau2*dph2+p0-ph2)/grue2+phat
      term2b = tau2/grue2+(tau2-tau20)*dphat
      if (term2a .ne. 0.d0) then
          dtau2 = -term2b/term2a
      else
          write(6,*) 'term2a=',term2a
          stop
      endif
c
      dfp_relax = rhoa0*dtau1+rhob0*dtau2
c
c      write(66,*) 'left dfp_relax:'
c      write(66,*) 'dfp_relax=',dfp_relax,', p0=',p0
      return
c
      end
