c
c ----------------------------------------------------------------------
c
      double precision function ftemp_satu(temp0)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      common /ftemp_satu0/ p0
c
c     # equal Gibbs free energy
c     # Gibbs free energy: G(p,T) = h(T)-TS(p,T)
c
      cp1 = geos(1)*cv(1)
      cp2 = geos(2)*cv(2)
c
      h1  = cp1*temp0+cn(1)
      S1  = cp1*dlog(temp0)-(cp1-cv(1))*dlog(p0+bn(1))+dn(1)
      gb1 = h1-temp0*S1
c
      h2  = cp2*temp0+cn(2)
      S2  = cp2*dlog(temp0)-(cp2-cv(2))*dlog(p0+bn(2))+dn(2)
      gb2 = h2-temp0*S2
c
      ftemp_satu = gb2-gb1
c
c      write(66,*) 'ftemp_satu=',ftemp_satu,temp0,p0
      return
c
      end
c
c ----------------------------------------------------------------------
c
      double precision function dftemp_satu(temp0)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      common /ftemp_satu0/ p0
c
c     # derivative of the equation for
c     # equal Gibbs free energy with respect to temperature
c
      cp1 = geos(1)*cv(1)
      cp2 = geos(2)*cv(2)
      S1  = cp1*dlog(temp0)-(cp1-cv(1))*dlog(p0+bn(1))+dn(1)
      S2  = cp2*dlog(temp0)-(cp2-cv(2))*dlog(p0+bn(2))+dn(2)
c
      dh1 = cp1
      dh2 = cp2
      dS1 = cp1/temp0
      dS2 = cp2/temp0
c
c     # this gives specific entropy 
      dgb1 = dh1-(temp0*dS1+S1)
      dgb2 = dh2-(temp0*dS2+S2)
c
      dftemp_satu = dgb2-dgb1
      return
c
      end
