c
c -------------------------------------------------------------
c
      subroutine out1(maxmx,meqn,mbc,mx,xlower,dx,q,t,iframe,
     &           aux,maux,work,mwork)
      implicit double precision (a-h,o-z)
      common /eos_local/ rhoe1,rhoe2,temp1,temp2,
     &        S1,S2,gb1,gb2,zeta1,zeta2
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension work(mwork)
      dimension qloc(20),qp(20)
      character*10 fname1,fname2,fname3
      logical outaux
c
c     # Output the results for a general system of conservation laws
c     # in 1 dimension
c
c     # Write the results to the file fort.c<iframe>
c     # first create the file name and open file
c
      fname1 = 'fort.qxxxx'
      fname2 = 'fort.txxxx'
      fname3 = 'fort.axxxx'
      nstp = iframe
      do ipos=10,7,-1
         idigit = mod(nstp,10)
         fname1(ipos:ipos) = char(ichar('0')+idigit)
         fname2(ipos:ipos) = char(ichar('0')+idigit)
         fname3(ipos:ipos) = char(ichar('0')+idigit)
         nstp = nstp/10
         enddo    
c
      open(unit=50,file=fname1,status='unknown',form='formatted')
      open(unit=60,file=fname2,status='unknown',form='formatted')
c
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr   = 1
      level  = 1
c
      write(50,1001) mptr,level,mx
      write(50,1002) xlower,dx
c
      do i=1,mx
         do m=1,meqn
            qloc(m) = q(i,m)
            enddo
c
         call ctomfd(qloc,qp(1),qp(2),qp(3),rhoh0,qp(4),
     &        pa0,pb0,qp(5),zeta0,qp(6),qp(7),
     &        c2a0,c2b0,qp(8))  
c
         qp(9)  = temp1  
         qp(10) = temp2  
         qp(11) = S1     
         qp(12) = S2     
         qp(13) = gb1
         qp(14) = gb2
c 
         do m=1,14
c           # exponents with more than 2 digits cause problems reading
c           # into matlab... reset tiny values to zero:
            if (dabs(qp(m)) .lt. 1d-30) qp(m) = 0.d0
            enddo
c
         write(50,1005) aux(i,2),(qp(m),m=1,14)
         enddo   
c
      mvarout = 15
      write(60,1000) t,mvarout,ngrids,maux

      close(unit=50)
      close(unit=60)
c
 1000 format(e26.16,'    time', /,
     &       i8,'                 meqn'/,
     &       i8,'                 ngrids'/,
     &       i8,'                 maux'/,/)
 1001 format(i8,'                 grid_number',/,
     &       i8,'                 AMR_level',/,
     &       i8,'                 mx')
 1002 format(e18.8,'    xlow', /,
     &       e18.8,'    dx', /)
 1005 format(15e24.10)
      end
