c
c ------------------------------------------------------------
c
      subroutine pT_solver(qpT_relax,qloc,meqn,dt,
     &           is_admissible)
      implicit double precision (a-h,o-z)
      parameter(tolp=1.0d-15)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      common /eos_local/ rhoe1,rhoe2,
     &        temp1,temp2,S1,S2,gb1,gb2,
     &        zeta1,zeta2
      common /trelx0/ rhoa0,rhob0,Y10,Y20,tau0,e0,temp0
      dimension qloc(20)
      dimension qpT_relax(20)
c
c     # 6-equation model with partial total energy
c     # instantaneous p-T relaxation
c
c     # temperature relaxation towards thermal equilibrium
c     # this should be done while pressure retains in equilibrium
c
      is_admissible = 1
c
      grue1 = geos(1)-1.d0
      grue2 = geos(2)-1.d0
c
      do m=1,meqn
         qpT_relax(m) = qloc(m)
         enddo
c
      call ctomfd(qloc,rhoa0,rhob0,vx0,rhoh0,p0,
     &     pa0,pb0,temp0,zeta0,zfa0,zfb0,
     &     c2a0,c2b0,c20)
c
      tau0  = 1.d0/(rhoa0+rhob0)
      Y10   = rhoa0/(rhoa0+rhob0)
      Y20   = rhob0/(rhoa0+rhob0)
      rhoe0 = zfa0*rhoe1+zfb0*rhoe2
      e0    = rhoe0/(rhoa0+rhob0)
c
c     # thermal equilibrium test
      fpT0 = fpT_relax(p0)
      if (dabs(fpT0) .lt. tolp) return
c
c     # set coefficients for quadratic equation
c     # of pressure
      z0 = rhoe0-(rhoa0*cn(1)+rhob0*cn(2))
      z1 = Y10*cv(1)
      z2 = Y20*cv(2)
      z3 = grue1*z1
      z4 = grue2*z2
      aa = -(z1+z2)
      bb = z0*z3+z0*z4-
     &     (z1*(geos(1)*bn(1)+bn(2))+
     &     z2*(geos(2)*bn(2)+bn(1)))
      cc = z0*z3*bn(2)+z0*z4*bn(1)-
     &     (z1*geos(1)*bn(1)*bn(2)+
     &     z2*geos(2)*bn(2)*bn(1))
      dd = bb**2-4.d0*aa*cc
c
c     # relaxed pressure
      if (dd .lt. 0.d0) then
          write(6,*) 
     &    'error in trelax1:bb**2-4.d0*aa*cc=',dd
c
          is_admissible = -1
          return
      else if (cc .eq. 0.d0) then
           pt = -bb/aa
      else
           pt1 = 0.5d0*(-bb-dsqrt(dd))/aa
           pt2 = 0.5d0*(-bb+dsqrt(dd))/aa
           pt  = dmax1(pt1,pt2)
      endif
c
      if (pt .lt. pcav(1)) then
          write(66,*) 'pT_solver: pt < pcav(1), pt=',pt,
     &                ', pcav(1)=',pcav(1)
c
          is_admissible = 0
          return
      else
          tempt = tau0/(z3/(pt+bn(1))+z4/(pt+bn(2)))
          tau1  = grue1*cv(1)*tempt/(pt+bn(1))
          tau2  = grue2*cv(2)*tempt/(pt+bn(2))
          zfa1  = rhoa0*tau1
          zfb1  = rhob0*tau2
      endif
c
      rho1 = 1.d0/tau1    
      rho2 = 1.d0/tau2
      vx0  = qloc(3)/(qloc(1)+qloc(2))
c
      zf0_color = qloc(8)
c
      call prmtoc(qpT_relax,rho1,rho2,
     &     vx0,pt,pt,zfa1,zfb1,zf0_color)
      return
c
      end
