c
c ------------------------------------------------------------
c
      double precision function pTg_relax0(p0,p0_5eqn,
     &                 rhoa0,rhob0,pa0,pb0,c2a0,c2b0,
     &                 zfa0,zfb0)
      implicit double precision (a-h,o-z)
c
c     # chemical potential (Gibbs free energy) relaxation
c     # initial guess for iterative solver
c
      rho10 = rhoa0/zfa0
      rho20 = rhob0/zfb0
      p10   = pa0/zfa0
      p20   = pb0/zfb0
      zc10  = rho10*dsqrt(c2a0)
      zc20  = rho20*dsqrt(c2b0)
      phat1 = ((p10/zc10)+(p20/zc20))/
     &        ((1.d0/zc10)+(1.d0/zc20))
c
      zc10  = rho10*c2a0
      zc20  = rho20*c2b0
      phat2 = ((pa0/zc10)+(pb0/zc20))/
     &        ((zfa0/zc10)+(zfb0/zc20))
c
      pTg_relax0 = dmax1(p0,p0_5eqn,phat1,phat2)
c
c      if (pTg_relax0 .lt. 0.d0) then
          write(66,*) 'pTg_relax0=',pTg_relax0
          write(66,*) 'p0=',p0
          write(66,*) 'p0_5eqn=',p0_5eqn
          write(66,*) 'phat1=',phat1   
          write(66,*) 'phat2=',phat2   
c          stop
c      endif
      return
c
      end
