c
c ------------------------------------------------------------
c
      subroutine pTg_relax(maxmx,mbc,mx,meqn,maux,
     &           q,qold,aux,auxold,dt)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension qold(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension auxold(1-mbc:maxmx+mbc,maux)
      dimension qpTg_relax(20),qloc(20)
c
c     # homogeneous relaxation model for
c     # compressible multiphase flow
c     # Gibbs free energy relaxation
c
c      write(66,*) 'entered mrelax_solver'
c
      do i=1,mx              
         do m=1,meqn
            qloc(m) = q(i,m)
            enddo
c
         is_meta = meta_stable(qloc,meqn) 
c
         if (is_meta .lt. 0) then
c            # pure-phase state

             do m=1,meqn
                q(i,m) = qloc(m)
                enddo
         else if (is_meta .eq. 1) then
c            # metastable state
c
c            # solve for pTg equilibrium 
             call pTg_solver(qpTg_relax,qloc,meqn,dt,
     &            is_admissible)
c
             if (is_admissible .eq. 1) then     
c                # admissible state
c
                 do m=1,meqn
                    q(i,m) = qpTg_relax(m)
                    enddo
             elseif (is_admissible .eq. 2) then 
c                # non-admissible state   
c                # over-relaxation case
c                # use alternate approach for pTg equilibrium
c
                 call a4pTg_solver(qpTg_relax,qloc,meqn,dt,
     &                is_admissible)
c
                 if (is_admissible .eq. 1) then
c                    # admissible state
c
                     do m=1,meqn
                        q(i,m) = qpTg_relax(m)
                        enddo
                 else
c                    # non-admissible state   
c
                     write(6,*) 'a4pTg_solver: non-admissible'
                     stop
                 endif
             elseif (is_admissible .eq. -2) then
c                   # nonconvergence case
c                   # pseudo finite-rate relaxation
c
                    do m=1,meqn
                       q(i,m) = qpTg_relax(m)
                       enddo
             else
                 write(66,*) 'is_admissible=',is_admissible
                 write(66,*) 'i=',i
                 write(66,*) 'qloc=',(qloc(m),m=1,meqn)     
                 write(66,*) 'qpTg=',(qpTg_relax(m),m=1,meqn)     
                 stop
             endif      
         endif      
         enddo
      return
c
      end
