c
c ------------------------------------------------------------
c
      subroutine p_relax(maxmx,mbc,mx,meqn,maux,
     &           q,qold,aux,auxold,dt)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension qold(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension auxold(1-mbc:maxmx+mbc,maux)
      dimension qp_relax(20)
      dimension qloc(20)
      dimension auxloc(20)
c
c     # homogeneous relaxation model 
c     # pressure relaxation towards mechanical equilibrium
c
      do i=1,mx
         do m=1,meqn
            qloc(m) = q(i,m)
            enddo
c
         do ma=1,maux
            auxloc(ma) = aux(i,ma)
            enddo
c
         call p_solver(qp_relax,qloc,auxloc,meqn,dt,iflag)
c
         if (iflag .eq. 1) then
c            # admissible state
c
             do m=1,meqn
                q(i,m) = qp_relax(m)
                enddo
         else
c            # non-admissible state
c
             call a4p_solver(qp_relax,qloc,auxloc,meqn,
     &            dt,iflag)
c
             if (iflag .eq. 1) then
c                # admissible state
c
                 do m=1,meqn
                    q(i,m) = qp_relax(m)
                    enddo
             else
c                # non-admissible state
c
                 write(66,*) 'p_relax: non-admissible'
                 write(66,*) 'i=',i
                 write(66,*) 'qloc=',(qloc(m),m=1,meqn)
                 write(66,*) 'qp_relax=',(qp_relax(m),m=1,meqn)
                 stop
             endif
         endif
         enddo          
      return
c
      end
