c
c ------------------------------------------------------------
c
      subroutine p_solver(qp_relax,qloc,auxloc,
     &           meqn,dt,is_admissible) 
      implicit double precision (a-h,o-z)
      parameter(tolp=1.0d-15)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &       dn(10),en(10),rref(10),c2ref(10),tref(10),
     &       cv(10),emu(10),rhocav(10),pcav(10),
     &       ccav(10),rhosat(10),psat(10),csat(10),
     &       rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &       mwoods,mphase
      common /prelx0/ rhoa0,rhob0,
     &        rho10,rho20,e10,e20,phat0
      common /eos_local/ rhoe1_local,rhoe2_local,
     &        temp10,temp20,S10,S20,
     &        gb10,gb20,zeta10,zeta20
      dimension qloc(20)
      dimension auxloc(20)
      dimension qp_relax(20)
c
c     # 6-equation model with partial total energy
c     # mechanical-equilibrium solver of pressure
c     # 2-phase case
c     # quadratic solution case
c
c      write(66,*) 'entered psolver'
c
      is_admissible = 1
c
      do m=1,meqn
         qp_relax(m) = qloc(m)
         enddo
c
      call ctomfd(qloc,rhoa0,rhob0,vx0,rhoh0,p0,
     &     pa0,pb0,temp0,zeta0,zfa0,zfb0,
     &     c2a0,c2b0,c20)
c
      rho10 = rhoa0/zfa0
      rho20 = rhob0/zfb0
      e10   = rhoe1_local/rho10
      e20   = rhoe2_local/rho20
      phat0 = p0
c
c     # mechanical equilibrium test
      fp0 = fp_relax(p0)
      if (dabs(fp0) .lt. tolp) return
c
      grue1  = geos(1)-1.d0
      grue2  = geos(2)-1.d0
      rhoe10 = rhoe1_local-rho10*cn(1)
      rhoe20 = rhoe2_local-rho20*cn(2)
c
c     # compute relaxed pressure
c     # setup quadratic polynomial coefficients
c     # (this is valid when stiffened gas EOS is used)
      p1   = pa0/zfa0
      p2   = pb0/zfb0
      z1   = p1+geos(1)*bn(1)
      z2   = p2+geos(2)*bn(2)
c
      aa = zfa0*geos(2)*grue1+
     &     zfb0*geos(1)*grue2-
     &     geos(1)*geos(2)
      bb = zfa0*geos(2)*(z1+grue1*bn(2))+
     &     zfb0*geos(1)*(z2+grue2*bn(1))-
     &     geos(1)*geos(2)*(bn(1)+bn(2))
      cc = zfa0*geos(2)*z1*bn(2)+
     &     zfb0*geos(1)*z2*bn(1)-
     &     geos(1)*geos(2)*bn(1)*bn(2)
c
      if (bb**2-4.d0*aa*cc .lt. 0.d0) then
          write(6,*) 'error in prelax1:',bb**2-4.d0*aa*cc
c
          is_admissible = -1
          return
      else
          pm1 = 0.5d0*(-bb-dsqrt(bb**2-4.d0*aa*cc))/aa
          pm2 = 0.5d0*(-bb+dsqrt(bb**2-4.d0*aa*cc))/aa
          pm  = dmax1(pm1,pm2)
      endif
c
      if (pm .lt. pcav(1)) then
c         # non-admissible state
c
          write(66,*) 'pm < pcav(1): pm=',pm,
     &                ', pcav(1)=',pcav(1)
c
          is_admissible = 0
          return
      else
          rhoe1 = (pm+geos(1)*bn(1))/grue1
          rhoe2 = (pm+geos(2)*bn(2))/grue2
c
          zfa1 = zfa0*(rhoe10+pm)/(rhoe1+pm)
          zfb1 = zfb0*(rhoe20+pm)/(rhoe2+pm)
      endif
c
      rho1 = qloc(1)/zfa1
      rho2 = qloc(2)/zfb1
      vx0  = qloc(3)/(qloc(1)+qloc(2))
c
      zf0_color = qloc(8)
c
      call prmtoc(qp_relax,rho1,rho2,
     &     vx0,pm,pm,zfa1,zfb1,zf0_color)
      return
c
      end
