function plotsnap(m,j)
%
% readin initial condition
fid = fopen('fort.t0000');
t0   = fscanf(fid,'%g',1);        fscanf(fid,'%s',1);
meqn = fscanf(fid,'%d',1);      fscanf(fid,'%s',1);
ngrids = fscanf(fid,'%d',1);    fscanf(fid,'%s',1);
fclose(fid);
%
fid = fopen('fort.q0000');
gridno = fscanf(fid,'%d',1);     fscanf(fid,'%s',1);
level = fscanf(fid,'%d',1);      fscanf(fid,'%s',1);
mx = fscanf(fid,'%d',1);         fscanf(fid,'%s',1);
xlow = fscanf(fid,'%g',1);       fscanf(fid,'%s',1);
dx = fscanf(fid,'%g',1);         fscanf(fid,'%s',1);
%
data0 = fscanf(fid,'%g',[meqn inf]);
status = fclose(fid);
data0 = data0';
%
clf
% snap shot
n1 = j+10000;
fname = ['fort.',num2str(n1)];
fname(6) = 't';
fid  = fopen(fname);
t1   = fscanf(fid,'%g',1);        fscanf(fid,'%s',1);
meqn = fscanf(fid,'%d',1);      fscanf(fid,'%s',1);
ngrids = fscanf(fid,'%d',1);    fscanf(fid,'%s',1);
fclose(fid);
%
fname(6) = 'q';
fid    = fopen(fname);
%
gridno = fscanf(fid,'%d',1);     fscanf(fid,'%s',1);
level = fscanf(fid,'%d',1);      fscanf(fid,'%s',1);
mx = fscanf(fid,'%d',1);         fscanf(fid,'%s',1);
xlow = fscanf(fid,'%g',1);       fscanf(fid,'%s',1);
dx = fscanf(fid,'%g',1);         fscanf(fid,'%s',1);
%
data1  = fscanf(fid,'%g',[meqn inf]);
status = fclose(fid);
data1 = data1';
%
framest = [num2str(j)];
%
xmin  = min(min(data0(:,1)));
xmax  = max(max(data0(:,1)));
%
if m==1
   q0 = (data0(:,2)+data0(:,3));          
   q1 = (data1(:,2)+data1(:,3));
elseif m==2
   q0 = data0(:,4);          
   q1 = data1(:,4);
elseif m==3
   q0 = data0(:,5);          
   q1 = data1(:,5);
elseif m==4
   q0 = data0(:,7);          
   q1 = data1(:,7);
elseif m==5
   q0 = data0(:,2)./(data0(:,2)+data0(:,3));          
   q1 = data1(:,2)./(data1(:,2)+data1(:,3));          
end

plot(data0(:,1),q0,'--',...
     data1(:,1),q1,'-') 
%
xlabel 'x'
legend('t = 0','t=0.58ms',...
          'Location','SouthEast')
%
set(gca,'fontsize',18);
if m==1
   title 'rho'  
   print -depsc cavi500_6Eqns_p_relax_rho
elseif m==2
   title 'vel'  
   print -depsc cavi500_6Eqns_p_relax_vel
elseif m==3
   title 'pr'  
   print -depsc cavi500_6Eqns_p_relax_pr
elseif m==4
   title 'vapor volume fraction'  
   print -depsc cavi500_6Eqns_p_relax_alphav   
elseif m==5
   title 'vapor mass fraction'  
   print -depsc cavi500_6Eqns_p_relax_Yv
end
end
