c
c ------------------------------------------------------------
c
      subroutine a4pTg_solver(qpTg_relax,qloc,meqn,dt,
     &           is_admissible)
      implicit double precision (a-h,o-z)
      common /mfluid/ geos(10),an(10),bn(10),cn(10),
     &        dn(10),en(10),rref(10),c2ref(10),tref(10),
     &        cv(10),emu(10),rhocav(10),pcav(10),
     &        ccav(10),rhosat(10),psat(10),csat(10),
     &        rhovm1(10),rhovm2(10),psi(10),zf(10),zv(10),
     &        mwoods,mphase
      common /eos_local/ rhoe10,rhoe20,temp10,temp20,
     &        S10,S20,gb10,gb20,zeta10,zeta20
      common /admissible_data0/ Yeps,zfeps
      dimension qpTg_relax(20),qloc(20)
c
c     # 6-equation model with partial total energy
c     # alternate solver for non-admissible solution
c     # of instantaneous p-T-g relaxation 
c
c     # entropy maximization approach
c     # mass-fraction case
c
      cp1 = geos(1)*cv(1)
      cp2 = geos(2)*cv(2)
c
      call ctomfd(qloc,rhoa0,rhob0,vx0,rhoh0,
     &     p0,pa0,pb0,temp0,zeta0,zfa0,zfb0,
     &     c2a0,c2b0,c20)
c
      rho0 = rhoa0+rhob0
      Y10  = rhoa0/(rhoa0+rhob0)
      Y20  = rhob0/(rhoa0+rhob0)
c
c     # mixture specific internal energy
      e0 = (zfa0*rhoe10+zfb0*rhoe20)/(rhoa0+rhob0)
c
c     # reset mass fraction
      if (S10 .gt. S20) then
          Y2ptg = dmin1(Yeps,Y20)
          Y1ptg = 1.d0-Y2ptg
      else
          Y1ptg = dmin1(Yeps,Y10)
          Y2ptg = 1.d0-Y1ptg  
      endif
c
c     # compute equilibrium pressure    
c     # set parameters
      z1 = cv(1)*Y1ptg
      z2 = cv(2)*Y2ptg
      w1 = rho0*Y1ptg*(cp1-cv(1))
      w2 = rho0*Y2ptg*(cp2-cv(2))
      w0 = e0-(Y1ptg*cn(1)+Y2ptg*cn(2))
c
c     # coefficients for quadratic polynomial of pressure
      aa = z1+z2
      bb = z1*(bn(2)+geos(1)*bn(1))+
     &     z2*(bn(1)+geos(2)*bn(2))-
     &     w0*(w1+w2)
      cc = z1*geos(1)*bn(1)*bn(2)+
     &     z2*geos(2)*bn(1)*bn(2)-
     &     w0*(w1*bn(2)+w2*bn(1))
c
      dd = bb**2-4.d0*aa*cc
      if (dd .lt. 0.d0) then
          write(66,*) 'error in a4msolver_pTg_SmaxY: dd=',dd
          stop
      endif
c
      pptg = 0.5d0*(-bb+dsqrt(dd))/aa
c
      temptg  = 1.d0/(w1/(pptg+bn(1))+w2/(pptg+bn(2)))
      rho1ptg = (pptg+bn(1))/((cp1-cv(1))*temptg)
      rho2ptg = (pptg+bn(2))/((cp2-cv(2))*temptg)
      zfaptg  = Y1ptg*rho0/rho1ptg
      zfbptg  = Y2ptg*rho0/rho2ptg
c
      zf0_color = qloc(8)
c
c     # reinitialize state variables
      call prmtoc(qpTg_relax,rho1ptg,rho2ptg,vx0,pptg,
     &     zfaptg,zfbptg,zf0_color)
c
      is_admissible = 1
      return
c
      end
