c
c ---------------------------------------------------------------------
c
      subroutine q2qlqr_interp(maxm,meqn,mwaves,mbc,maux,mx,
     &           dt,dx,q,aux,ql,qr,auxl,auxr,s,wave,qp,dq,
     &           uu,hh,evl,evr,mthlim)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxm+mbc,meqn)
      dimension aux(1-mbc:maxm+mbc,maux)
      dimension ql(1-mbc:maxm+mbc,meqn)
      dimension qr(1-mbc:maxm+mbc,meqn)
      dimension auxl(1-mbc:maxm+mbc,maux)
      dimension auxr(1-mbc:maxm+mbc,maux)
      dimension wave(1-mbc:maxm+mbc,meqn,mwaves)
      dimension s(1-mbc:maxm+mbc,mwaves)
      dimension qp(1-mbc:maxm+mbc,meqn)
      dimension dq(1-mbc:maxm+mbc,meqn)
      dimension uu(1-mbc:maxm+mbc,meqn,2)
      dimension hh(1-mbc:maxm+mbc,-2:2)
      dimension evl(1-mbc:maxm+mbc,meqn,mwaves)
      dimension evr(1-mbc:maxm+mbc,meqn,mwaves)
      dimension mthlim(mwaves)
c
c     # piecewise-linear TVD reconstruction 
c
      dxhalf = 0.5d0*dx
c
c     # piecewise-constant for auxiliary state
      do ma=1,maux
         do i=2-mbc,mx+mbc
            auxr(i-1,ma) = aux(i-1,ma)
            auxl(i,ma)   = aux(i,ma)
            enddo
         enddo
c
      do m=1,meqn
         do i=2-mbc,mx+mbc
            qr(i-1,m) = q(i-1,m)
            ql(i,m)   = q(i,m)
            enddo
         enddo
c
      do i=1-mbc,mx+mbc
         if (i .eq. 1-mbc) then
             do m=1,meqn
                dq(i,m) = (q(i+1,m)-q(i,m))/dx
                enddo
         else if (i .eq. mx+mbc) then
             do m=1,meqn
                dq(i,m) = (q(i,m)-q(i-1,m))/dx
                enddo
         else
             dL = dabs(aux(i,2)-aux(i-1,2))
             dR = dabs(aux(i+1,2)-aux(i,2))
c
             do m=1,meqn
                dqL = (q(i,m)-q(i-1,m))/dx
                dqR = (q(i+1,m)-q(i,m))/dx
                if (dabs(dqL) .lt. 1.d-20) then
                    dq(i,m) = 0.0d0
                else
                    dq(i,m) = philim(dqL,dqR,mthlim(1))*dqL
                endif
                enddo
         endif
         enddo
c
      do m=1,meqn
         do i=1-mbc,mx+mbc
            ql(i,m) = q(i,m)-dxhalf*dq(i,m)
            qr(i,m) = q(i,m)+dxhalf*dq(i,m)
            enddo
         enddo
      return
c
      end
