c
c ---------------------------------------------------------------------
c
      subroutine step1(maxmx,meqn,mwaves,mbc,maux,mx,
     &           q,qold,ql,qr,dq,aux,auxold,auxl,auxr,
     &           dx,t,dt,method,
     &           mthlim,cfl,s,amdq,apdq,amdq2,apdq2,
     &           dtdx,wave,qrp1,qrp2,mthbc,work,mwork)
      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc,meqn)
      dimension qold(1-mbc:maxmx+mbc,meqn)
      dimension ql(1-mbc:maxmx+mbc,meqn)
      dimension qr(1-mbc:maxmx+mbc,meqn)
      dimension dq(1-mbc:maxmx+mbc,meqn)
      dimension aux(1-mbc:maxmx+mbc,maux)
      dimension auxold(1-mbc:maxmx+mbc,maux)
      dimension auxl(1-mbc:maxmx+mbc,maux)
      dimension auxr(1-mbc:maxmx+mbc,maux)
      dimension s(1-mbc:maxmx+mbc,mwaves)
      dimension wave(1-mbc:maxmx+mbc,meqn,mwaves)
      dimension amdq(1-mbc:maxmx+mbc,meqn)
      dimension apdq(1-mbc:maxmx+mbc,meqn)
      dimension amdq2(1-mbc:maxmx+mbc,meqn)
      dimension apdq2(1-mbc:maxmx+mbc,meqn)
      dimension qrp1(1-mbc:maxmx+mbc,meqn)
      dimension qrp2(1-mbc:maxmx+mbc,meqn)
      dimension dtdx(1-mbc:maxmx+mbc)
      dimension method(10)
      dimension mthlim(mwaves)
      dimension mthbc(2)
      dimension work(mwork)
c
c     # Evaluate (delta t)*dq(t)/dt
c
c     # set up pointers i0evl, i0evr here
      i0evl  = 1
      i0evr  = i0evl+(maxmx+2*mbc)*meqn*mwaves
      i0uu   = i0evr+(maxmx+2*mbc)*meqn*mwaves
      i0hh   = i0uu+(maxmx+2*mbc)*meqn*2
      i0q1l  = i0hh+(maxmx+2*mbc)*5
      i0q1r  = i0q1l+(maxmx+2*mbc)*meqn
      i0q2l  = i0q1r+(maxmx+2*mbc)*meqn
      i0q2r  = i0q2l+(maxmx+2*mbc)*meqn
      i0next = i0q2r+(maxmx+2*mbc)*meqn
      i0used = i0next-1
c
      if (i0used .gt. mwork) then
          write(6,*) '*** not enough work space in step1'
          write(6,*) '*** i0used= ', i0used, '  mwork = ',mwork
          stop
      endif
c
      mcapa = method(6)
      do i=1-mbc,mx+mbc
         if (mcapa .gt. 0) then
             dtdx(i) = dt/(dx*aux(i,mcapa))
         else
             dtdx(i) = dt/dx
         endif
         enddo
c
      do m=1,meqn
         do i=1-mbc,mx+mbc
            dq(i,m) = 0.d0
            enddo
         enddo
c
c     # first evaluate source terms
c     # evaluate (delta t)*psi(q,t) and store in dq
      if (method(5) .eq. 1) then
          call src1(maxmx,mbc,mx,meqn,maux,xlower,dx,q,
     &         qold,aux,auxold,dq,work,mwork,t,dt)
      endif
c
      go to (9,10,20,30,40) method(9)+1
c
 9    continue
c     # piecewise constant reconstruction  
c
      call q2qlqr(maxmx,meqn,mbc,maux,mx,dt,dx,
     &     q,aux,ql,qr,auxl,auxr,amdq,1)
      go to 90
c
 10   continue
c     # higher-order reconstruction
c
      call q2qlqr_interp(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,ql,qr,auxl,auxr,s,wave,amdq,apdq,
     &     work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,ql,qr,
     &     maux,auxl,auxr,t,dt,mthbc)
      go to 90
c
 20   continue
c     # hybrid THINC & higher-order reconstruction
c
c     # higher-order reconstruction step
      call q2qlqr_interp(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,ql,qr,auxl,auxr,s,wave,amdq,apdq,
     &     work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # THINC reconstruction step
      call q2qlqr(maxmx,meqn,mbc,maux,mx,dt,dx,
     &     q,aux,ql,qr,auxl,auxr,amdq,0)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,ql,qr,
     &     maux,auxl,auxr,t,dt,mthbc)
      go to 90
c
 30   continue
c     # boundary variation diminishing reconstruction
c     # THINC-based
c
c     # reconstruction scheme 1
      call q2qlqr_interp(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,work(i0q1l),work(i0q1r),auxl,auxr,
     &     s,wave,amdq,apdq,work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,
     &     work(i0q1l),work(i0q1r),
     &     maux,auxl,auxr,t,dt,mthbc)
c
c     # reconstruction scheme 2 
      call q2qlqr_interp2(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,work(i0q2l),work(i0q2r),auxl,auxr,
     &     s,wave,amdq,apdq,work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,
     &     work(i0q2l),work(i0q2r),
     &     maux,auxl,auxr,t,dt,mthbc)
c
c     # THINC (modification)
      call q2qlqr(maxmx,meqn,mbc,maux,mx,dt,dx,
     &     q,aux,work(i0q2l),work(i0q2r),auxl,auxr,amdq,0)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,
     &     work(i0q2l),work(i0q2r),
     &     maux,auxl,auxr,t,dt,mthbc)
c
c     # bvd reconstruction
      call q2qlqr_bvd(maxmx,meqn,mbc,maux,mx,dx,
     &     q,aux,ql,qr,auxl,auxr,
     &     work(i0q1l),work(i0q1r),work(i0q2l),work(i0q2r),
     &     amdq,apdq,amdq2,apdq2,work(i0uu))
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,ql,qr,
     &     maux,auxl,auxr,t,dt,mthbc)
      go to 90
c
 40   continue
c     # boundary variation diminishing reconstruction
c
c     # reconstruction scheme 1
      call q2qlqr_interp(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,work(i0q1l),work(i0q1r),auxl,auxr,
     &     s,wave,amdq,apdq,work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,
     &     work(i0q1l),work(i0q1r),
     &     maux,auxl,auxr,t,dt,mthbc)
c
c     # reconstruction scheme 2
      call q2qlqr_interp2(maxmx,meqn,mwaves,mbc,maux,mx,
     &     dt,dx,q,aux,work(i0q2l),work(i0q2r),auxl,auxr,
     &     s,wave,amdq,apdq,work(i0uu),work(i0hh),
     &     work(i0evl),work(i0evr),mthlim)
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,
     &     work(i0q2l),work(i0q2r),
     &     maux,auxl,auxr,t,dt,mthbc)
c
c     # bvd reconstruction
      call q2qlqr_bvd(maxmx,meqn,mbc,maux,mx,dx,
     &     q,aux,ql,qr,auxl,auxr,
     &     work(i0q1l),work(i0q1r),work(i0q2l),work(i0q2r),
     &     amdq,apdq,amdq2,apdq2,work(i0uu))
c
c     # set boundary condition 
      call bc1_lr(maxmx,meqn,mbc,mx,xlower,dx,ql,qr,
     &     maux,auxl,auxr,t,dt,mthbc)
      go to 90
c
 90   continue        
c     # solve Riemann problem at each interface 
      call rp1(maxmx,meqn,mwaves,mbc,maux,mx,ql,qr,
     &     auxl,auxr,wave,s,amdq,apdq,qrp1,dtdx)

c     # compute maximum wave speed:
      cfl = 0.d0
      do mw=1,mwaves
         do i=1,mx+1
c           # if s>0 use dtdx(i) to compute CFL,
c           # if s<0 use dtdx(i-1) to compute CFL:
            cfl = dmax1(cfl,dtdx(i)*s(i,mw),-dtdx(i-1)*s(i,mw))
            enddo   
         enddo
c
c     # find total fluctuation within each cell
      if (method(8) .eq. 0) then
c         # ignore fluctutation within cells
          do m=1,meqn
             do i=1,mx
                dq(i,m) = dq(i,m)-
     &                    dtdx(i)*(apdq(i,m)+amdq(i+1,m))
                enddo
             enddo
      elseif (method(8) .eq. 1) then
c         # tfluct1 should be a special solver that uses the parameters aux(i)
c         # to solve a Riemann problem with left state ql(i)
c         # and right state qr(i), and returns a total fluctuation in amdq2
c         # NOTE that here amdq2 is really a total fluctuation (should be
c         # called adq); we do it this way just to avoid declaring more storage
c
          call tfluct1(maxmx,meqn,mwaves,mbc,maux,mx,ql,qr,auxl,auxr,
     &         s,amdq2)
c
c         # modify q using fluctuations:
c         # Note this may not correspond to a conservative flux-differencing
c         # for equations not in conservation form.  It is conservative if
c         # adq = f(qr(i)) - f(ql(i)).
c
          do m=1,meqn
             do i=1,mx
                dq(i,m) = dq(i,m)-dtdx(i)*(apdq(i,m)+
     &                            amdq2(i,m)+amdq(i+1,m))
                enddo
             enddo
      elseif (method(8) .eq. 2) then
c         # we can just swap things around and use the usual Riemann solver
c         # this may be more convenient, but is less efficient.
c
          do i=2-mbc,mx+mbc
             do m=1,meqn
                qr(i-1,m) = ql(i,m)
                ql(i,m)   = qr(i,m)
                enddo
c
             do ma=1,maux
                auxr(i-1,ma) = auxl(i,ma)
                auxl(i,ma)   = auxr(i,ma)
                enddo
             enddo
c
          call rp1(maxmx,meqn,mwaves,mbc,maux,mx-1,ql,qr,auxl,auxr,
     &         wave,s,amdq2,apdq2,qrp2,dtdx)
c
          do m=1,meqn
             do i=1,mx+1
                dq(i,m) = dq(i,m)-dtdx(i)*(amdq(i+1,m)+ 
     &                    apdq(i,m)+amdq2(i,m)+apdq2(i,m))
                enddo
             enddo
      endif
      return
c
      end
